Table of Contents
Problem
You are given an array books
where books[i] = [thicknessi, heighti]
indicates the thickness and height of the ith
book. You are also given an integer shelfWidth
.
We want to place these books in order onto bookcase shelves that have a total width shelfWidth
.
We choose some of the books to place on this shelf such that the sum of their thickness is less than or equal to shelfWidth
, then build another level of the shelf of the bookcase so that the total height of the bookcase has increased by the maximum height of the books we just put down. We repeat this process until there are no more books to place.
Note that at each step of the above process, the order of the books we place is the same order as the given sequence of books.
- For example, if we have an ordered list of
5
books, we might place the first and second book onto the first shelf, the third book on the second shelf, and the fourth and fifth book on the last shelf.
Return the minimum possible height that the total bookshelf can be after placing shelves in this manner.
Example 1:
Input: books = [[1,1],[2,3],[2,3],[1,1],[1,1],[1,1],[1,2]], shelfWidth = 4 Output: 6 Explanation: The sum of the heights of the 3 shelves is 1 + 3 + 2 = 6. Notice that book number 2 does not have to be on the first shelf.
Example 2:
Input: books = [[1,3],[2,4],[3,2]], shelfWidth = 6 Output: 4
Constraints:
1 <= books.length <= 1000
1 <= thicknessi <= shelfWidth <= 1000
1 <= heighti <= 1000
Solution
What this problem needs to solve is to calculate the minimum possible height of the bookshelf after placing all the books into the bookshelf. We can place one or more books on a shelf, as long as the total book width does not exceed shelfWidth
. A very important constraint in the problem is that all books must be placed in the bookshelf in their original order. This restriction narrows down the possible placement combinations.
The idea of solving the problem is that we place book 1 on the first shelf, and the remaining books 2 ~ 7 are placed from the next shelf. Or, we place book 1 and 2 on the first shelf, and the remaining books 3 ~ 7 are placed from the next shelf. We can no longer place book 3 because that would exceed shelfWidth
. Then, compare the heights of the first and second placement methods, and take the smallest one as the answer.
In the above idea, we did not explain how to calculate the final placement height of the remaining books. Because when placing the remaining books, it is also placing books recursively according to the above-mentioned idea.
Dynamic Programming
class Solution { public int minHeightShelves(int[][] books, int shelfWidth) { return minHeightShelves(books, shelfWidth, 0, new int[books.length]); } private int minHeightShelves(int[][] books, int shelfWidth, int index, int[] dp) { if (index >= books.length) return 0; if (dp[index] != 0) return dp[index]; int minHeight = Integer.MAX_VALUE; int height = 0; int width = 0; for (int i = index; i < books.length; i++) { width += books[i][0]; if (width > shelfWidth) break; height = Math.max(height, books[i][1]); minHeight = Math.min(minHeight, height + minHeightShelves(books, shelfWidth, i + 1, dp)); } dp[index] = minHeight; return minHeight; } }
Reference
- 1105. Filling Bookcase Shelves, LeetCode.
- 1105. Filling Bookcase Shelves, LeetCode Solutions.